﻿Type=Activity
Version=6.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
	'#BridgeLogger:True

#End Region
#Region DEFINITIONS
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
'STORAGE
Dim dispcounter As Int =  0
Dim interimList As List
'CHART
	Dim mbc1 As BarChart
	Dim prevval As Float = 0.0
	'UI LABELS
	Private LabelName As Label
	
	'PANELS
	Private PanelRight As Panel
	Private PanelLeft As Panel
	
	
	'PANEL POSITION STATUS
	Dim PanelLeftUP As Boolean= False
	Dim PanelRightUP As Boolean = False
		
		'MAPS
		Private gmap As GoogleMap
		Private MapFragment1 As MapFragment
	
  		
End Sub
#End Region


#Region System Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("Show")
	If MapFragment1.IsGooglePlayServicesAvailable = False Then
		ToastMessageShow("Please go to Android Market and install Google Play Services.", True)
	End If
interimList.Initialize
parseSegmentsIntoObjects
End Sub

Sub Activity_Resume
	
	
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub
#End Region

Sub initialSetupChart 
		
	'    RIGHT_OF_CHART, RIGHT_OF_CHART_CENTER, RIGHT_OF_CHART_INSIDE,
	'    LEFT_OF_CHART, LEFT_OF_CHART_CENTER, LEFT_OF_CHART_INSIDE,
	'    BELOW_CHART_LEFT, BELOW_CHART_RIGHT, BELOW_CHART_CENTER,

	'   LINE, CIRCLE, SQUARE
	
	'mbc1.LegendShapeSize = 7.0	    'this line of code needs to be before mbc1.setTheLegendPositionAndForm("BELOW_CHART_CENTER", "CIRCLE")
	'mbc1.setTheLegendPositionAndForm("BELOW_CHART_CENTER", "CIRCLE")    'pass strings from the above comments
	
'	mbc1.TheLegendColor = Colors.Cyan
'	mbc1.TheLegendTextSize = 1
'	mbc1.LegendTitle = "i.deas.digital.consultants"


	mbc1.BarColors = Array As Int(Colors.Cyan, Colors.Cyan, Colors.Cyan, Colors.Cyan, Colors.Cyan, Colors.Cyan, Colors.Cyan, Colors.Cyan, Colors.Cyan, Colors.Cyan, Colors.Cyan, Colors.Cyan)
		
	mbc1.ChartDescription = ""
	mbc1.ChartDescriptionColor = Colors.Blue
	mbc1.ChartDescriptionTextSize = 1
	'	mbc1.setDescriptionPosition(mbc1.left + 25%x ,mbc1.top + 3%y)
	
	mbc1.ValueTextColor = Colors.Black ' for each ?
	mbc1.ValueTextSize = 1
	mbc1.DrawValueAboveBar = False
	mbc1.DrawBarShadow = False
	mbc1.DrawHighlightArrow = False
	
	
	mbc1.GridBackgroundColor = Colors.ARGB(0,255,255,255)
	mbc1.DrawBorders = True
	mbc1.DrawGridBackground = True
	
	
	mbc1.DoubleTapToZoomEnabled = True
	mbc1.PinchZoom = True
	mbc1.ScaleEnabled = True
	mbc1.BorderColor = Colors.Cyan
	mbc1.BorderWidth = 1.0
	mbc1.DrawAxisLine=True
	
	'   TOP, BOTTOM, BOTH_SIDED, TOP_INSIDE, BOTTOM_INSIDE
	'mbc1.XaxisLabelPosition = "BOTTOM"
	mbc1.XaxisTextSize = 10
	mbc1.XaxisTextColor = Colors.Cyan
	mbc1.Color=Colors.BLACK ' THIS IS OUTSIDE THE BORDER
	mbc1.DrawYaxisGridLines = False
	mbc1.DrawAxisLine=True
	mbc1.YaxisTextColor = Colors.Cyan
	mbc1.YaxisTextSize = 10.0
	mbc1.ShowYaxisLeftLabels = True
	mbc1.ShowYaxisRightLabels = False
	mbc1.YAxisMinValue = 0                           'ADDED 29 October 2015
	mbc1.YAxisMaxValue = 110                          'ADDED 29 October 2015
	
	mbc1.MarkerToUse = 3
	
	
	
	mbc1.YAnimate = True
	mbc1.ChartAnimationTime = 2750
	
	populateChart
	
End Sub


'LOOP THROUGH THIS
Sub populateChart
	'the following 3 arrays must have the same number of entries/elements
	'LOOP TO POPULATE THESE
	Dim tempchartdata(150) As Float  
	'tempchartdata.Initialize
	Dim tempbarcolors (150)As Int
	'tempbarcolors.Initialize
	Dim templegendtext (150)As String
	'templegendtext.Initialize
	Dim i As Int = 0
	For Each item As segment In interimList
		Dim fl As Float = item.averageSpeed
		tempchartdata(i)=fl
		tempbarcolors(i)=Colors.Cyan
		templegendtext(i)=""
		i=i+1
		
	Next
	mbc1.BarColors = tempbarcolors
	mbc1.LegendText=templegendtext
	mbc1.ChartData=tempchartdata
	

mbc1.BarData = i+1   'this number must be the same as the number of elements in the above arrays
   
End Sub

'CHART TOUCH
Sub mbc1_bar_value(val As Float,index As Int)
	
	If prevval <> val Then 
	  Log("Current Value = " & val)
		prevval = val
		Log("index= "&index)
		dispcounter=index
		displaydata
	End If
End Sub



Sub parseSegmentsIntoObjects
	'Make a graph
	'make a map
	'show metrics
	
	If Main.parseddata.IsInitialized Then
		Dim findAllJourneys As Map
		findAllJourneys.Initialize
		findAllJourneys = Main.parseddata.Get("findAllJourneysResponse")
		Dim items As List = findAllJourneys.Get("return")
		Log( items.Get(Main.SelectedMotorway))
		Dim	item As Map
		item=items.Get(Main.SelectedMotorway)
		'			Dim averageSpeed As Int = item.Get("averageSpeed")
		'			Dim name As String= item.Get("name")
		Dim xsegment As List=item.Get("segments")
			
		For Each itemx As Map In xsegment
			Dim s As segment
			s.Initialize
			'SEGMENT_STATS
			s.averageSpeed=itemx.Get("averageSpeed")
			s.averageOccupancy=itemx.Get("averageOccupancy")
			s.sectionName=itemx.Get("sectionName")
			s.totalVolume=itemx.Get("totalVolume")
			s.sectionLength=itemx.Get("sectionLength")
			'SEGMENT_TYPE
			s.STgroupType=itemx.Get("groupType")
			s.STid=itemx.Get("id")
			Log ( "Section Name " & s.sectionName)
			Log ( "Avg Speed " & s.averageSpeed)
			Log ( "Occ: " & s.averageOccupancy)
			Log("Total Volume "&s.totalVolume)
			'Get end location Data
			Dim elo As Map
			elo.Initialize
			elo=itemx.Get("endLocation")
			'END_LOCATION
			s.ELdescription=elo.Get("description")
			s.ELlatitude=elo.Get("latitude")
			s.ELlongitude=elo.Get("longitude")
			s.ELspeedLimit=elo.Get("speedLimit")
			
			
			Log ( "EndLocation Desc " & s.ELdescription)
			
			'GEt Startlocation data
			Dim slo As Map
			slo.Initialize
			slo=itemx.Get("endLocation")
			s.SLdescription=slo.Get("description")
			s.SLlatitude=slo.Get("latitude")
			s.SLlongitude=slo.Get("longitude")
			s.SLspeedLimit=slo.Get("speedLimit")
			
			Log ( "StartLoc Desc " & s.SLdescription)
			'ADD OBJECT TO INTERIM LIST
			interimList.Add(s)
		
		Next
		
			initialSetupChart
	End If
End Sub




Sub displaydata
				If dispcounter > -1 And dispcounter < interimList.Size Then
				
				Dim s As segment
				s.Initialize
				s=interimList.Get (dispcounter)	
				'Log(Main.mapofclasses)

				'Log(s)
'				Dim sl As startlocation
'				sl.Initialize
'				sl = results.mapofclasses.Get(("sl"&dispcounter))
'				'Log(sl)
'				Dim el As endlocation
'				el.Initialize
'				el = results.mapofclasses.Get(("el"&dispcounter))
				'Log(el)
				
				LabelName .Text = s.sectionName
				'
					'REPOSITION MAP TO SHOW THIS SEGMENT
					Dim CP As CameraPosition
					CP.Initialize(s.ELlatitude,s.ELlongitude,14)
					gmap.AnimateCamera(CP)
				
End If
End Sub

'


Sub JobDone(Job1 As HttpJob)
	If Job1.Success Then
		If Job1.JobName="gileft" Then
			Log("were back")
			PanelLeft.SetBackgroundImage(Job1.GetBitmap)
		End If
		If Job1.JobName="giright" Then
			Log("were back")
			PanelRight.SetBackgroundImage(Job1.GetBitmap)
		End If
	End If
End Sub



Sub PanelRight_Click
	If PanelRightUP=False Then
		'FOR OPENING
		
		PanelRight.SetLayoutAnimated(1200,Activity.Width/2,(Activity.Height-Activity.Width/2),Activity.Width/2,Activity.Height/2)
		PanelRight.Left = 51%x
		Dim g As getweb
		g.Initialize
		g.getimageright("http://www.trafficnz.info/camera/235.jpg")
		PanelRightUP=True
	Else
		'FOR CLOSING
		PanelRight.SetLayoutAnimated(1200,Activity.Width/2, 97%y, Activity.Width/2,3%y)
		PanelRightUP=False
	End If
	
	
End Sub	

#Region

Sub MapFragment1_Ready ' DRAWS MAP
	Log("Map Ready")
	gmap = MapFragment1.GetMap
		
		Dim listofpolylines As List
		listofpolylines.Initialize
	'MAP TYPE
	'gmap.MapType=gmap.MAP_TYPE_NORMAL
	
	
	
	
	Dim listofpoints As List
	listofpoints.Initialize
	Dim counter As Int = 0 
	Dim pl As Polyline 
	
	'LOOP THROUGH SEGMENTS
	For Each item As segment In interimList
		 pl = gmap.AddPolyline
		
				
		'SET MARKERS
		Dim fl As Float = item.averageSpeed
		'create marker
		'Dim markerSL As Marker
		' set marker colour
		gmap.AddMarker2(item.SLlatitude,item.sllongitude,item.SLid&"group "&item.STgroupType&" vol "&Round(item.totalVolume) & " cars/min",gmap.HUE_GREEN)
		'Dim markerEL As Marker
		'set colour
		gmap.AddMarker2(item.ELlatitude,item.ELlongitude,item.ELid&"group "&item.STgroupType&" vol "&item.totalVolume & " cars/min",gmap.HUE_RED)
				
		' DRAW LINE
		Dim xPoint As LatLng
			  xPoint.Initialize(item.SLlatitude,item.sllongitude)
			 listofpoints.Add(xPoint)
			Dim xPoint As LatLng
			 xPoint.Initialize(item.ELlatitude,item.ellongitude)
		listofpoints.Add(xPoint)
			
		''CONFIG LINE
		'line colour based on speed (cars/min)
		Dim linecalcvar As Int
		'sets speedlimit to 100 if speedlimit = 0 which it does quite often
		If item.elspeedLimit = 0 Then
			item.elspeedLimit = 75
		End If
		linecalcvar = ((item.averageSpeed/item.elspeedlimit) * 100)
		Log(linecalcvar&" " & item.sectionName)
		If linecalcvar < 30 Then
			pl.Color =Colors.Black
		End If
		If linecalcvar >30 And linecalcvar<60 Then
			pl.Color=Colors.red
		End If
		If linecalcvar > 59 And linecalcvar < 80 Then
			pl.Color = Colors.RGB(255,165,0) 'orange
		End If
		If linecalcvar > 80  Then
			pl.Color = Colors.Green
		End If
		'
		'	 ' line width based on volume  (cars/min)
		If item.totalvolume <5 Then
			pl.width =5
		End If
		If item.totalvolume >9 And item.totalvolume<20 Then
			pl.width=10
		End If
		If item.totalvolume > 19 And item.totalvolume< 40 Then
			pl.width=20
		End If
		If item.totalvolume > 40  Then
			pl.width = 30
		End If
	
		
		pl.points=listofpoints
		'listofpolylines.Add(pl)
			
	Next
'For Each poly As Polyline In listofpolylines
'	poly=gmap.AddPolyline
'Next
	Log ("finished drawing map")
	
End Sub

